=begin
#API League

#API League is a Hub for World Class APIs.

The version of the OpenAPI document: 1.6.4
Contact: mail@apileague.com
Generated by: https://openapi-generator.tech
Generator version: 7.8.0-SNAPSHOT

=end

require 'cgi'

module OpenapiClient
  class FoodApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Compute Nutrition API
    # Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
    # @param ingredients [String] A comma-separated list of the ingredients of the recipe.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :servings The number of servings the ingredients make. Nutrition is computed per serving.
    # @option opts [Boolean] :reduce_oils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true.
    # @return [ComputeNutritionAPI200Response]
    def compute_nutrition_api(ingredients, opts = {})
      data, _status_code, _headers = compute_nutrition_api_with_http_info(ingredients, opts)
      data
    end

    # Compute Nutrition API
    # Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
    # @param ingredients [String] A comma-separated list of the ingredients of the recipe.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :servings The number of servings the ingredients make. Nutrition is computed per serving.
    # @option opts [Boolean] :reduce_oils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true.
    # @return [Array<(ComputeNutritionAPI200Response, Integer, Hash)>] ComputeNutritionAPI200Response data, response status code and response headers
    def compute_nutrition_api_with_http_info(ingredients, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FoodApi.compute_nutrition_api ...'
      end
      # verify the required parameter 'ingredients' is set
      if @api_client.config.client_side_validation && ingredients.nil?
        fail ArgumentError, "Missing the required parameter 'ingredients' when calling FoodApi.compute_nutrition_api"
      end
      if @api_client.config.client_side_validation && ingredients.to_s.length > 1000
        fail ArgumentError, 'invalid value for "ingredients" when calling FoodApi.compute_nutrition_api, the character length must be smaller than or equal to 1000.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && ingredients !~ pattern
        fail ArgumentError, "invalid value for 'ingredients' when calling FoodApi.compute_nutrition_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'servings'].nil? && opts[:'servings'] > 999
        fail ArgumentError, 'invalid value for "opts[:"servings"]" when calling FoodApi.compute_nutrition_api, must be smaller than or equal to 999.'
      end

      if @api_client.config.client_side_validation && !opts[:'servings'].nil? && opts[:'servings'] < 1
        fail ArgumentError, 'invalid value for "opts[:"servings"]" when calling FoodApi.compute_nutrition_api, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/compute-nutrition'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'ingredients'] = ingredients
      query_params[:'servings'] = opts[:'servings'] if !opts[:'servings'].nil?
      query_params[:'reduce-oils'] = opts[:'reduce_oils'] if !opts[:'reduce_oils'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ComputeNutritionAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"FoodApi.compute_nutrition_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FoodApi#compute_nutrition_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieve Recipe Information API
    # Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
    # @param id [Integer] The id of the recipe to retrieve.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :add_wine_pairing Whether to pair a wine to the recipe.
    # @return [RetrieveRecipeInformationAPI200Response]
    def retrieve_recipe_information_api(id, opts = {})
      data, _status_code, _headers = retrieve_recipe_information_api_with_http_info(id, opts)
      data
    end

    # Retrieve Recipe Information API
    # Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
    # @param id [Integer] The id of the recipe to retrieve.
    # @param [Hash] opts the optional parameters
    # @option opts [Boolean] :add_wine_pairing Whether to pair a wine to the recipe.
    # @return [Array<(RetrieveRecipeInformationAPI200Response, Integer, Hash)>] RetrieveRecipeInformationAPI200Response data, response status code and response headers
    def retrieve_recipe_information_api_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FoodApi.retrieve_recipe_information_api ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FoodApi.retrieve_recipe_information_api"
      end
      if @api_client.config.client_side_validation && id > 1410065407
        fail ArgumentError, 'invalid value for "id" when calling FoodApi.retrieve_recipe_information_api, must be smaller than or equal to 1410065407.'
      end

      if @api_client.config.client_side_validation && id < 0
        fail ArgumentError, 'invalid value for "id" when calling FoodApi.retrieve_recipe_information_api, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/retrieve-recipe'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'id'] = id
      query_params[:'add-wine-pairing'] = opts[:'add_wine_pairing'] if !opts[:'add_wine_pairing'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RetrieveRecipeInformationAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"FoodApi.retrieve_recipe_information_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FoodApi#retrieve_recipe_information_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Search Drinks API
    # Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [String] :glass_types A comma-separated list (interpreted as OR) of glass types that the drink should be served in.
    # @option opts [String] :flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink.
    # @option opts [String] :diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian.
    # @option opts [String] :include_ingredients A comma-separated list of ingredients that should/must be used in the drinks.
    # @option opts [String] :exclude_ingredients A comma-separated list of ingredients or ingredient types that the drinks must not contain.
    # @option opts [Float] :min_calories The minimum amount of calories the drink must have per serving.
    # @option opts [Float] :max_calories The maximum amount of calories the drink can have per serving.
    # @option opts [Float] :min_carbs The minimum amount of carbohydrates in grams the drink must have per serving.
    # @option opts [Float] :max_carbs The maximum amount of carbohydrates in grams the drink can have per serving.
    # @option opts [Float] :min_protein The minimum amount of protein in grams the drink must have per serving.
    # @option opts [Float] :max_protein The maximum amount of protein in grams the drink can have per serving.
    # @option opts [Float] :min_fat The minimum amount of fat in grams the drink must have per serving.
    # @option opts [Float] :max_fat The maximum amount of fat in grams the drink can have per serving.
    # @option opts [Float] :min_alcohol_percent The minimum alcohol percentage the drink must have.
    # @option opts [Float] :max_alcohol_percent The maximum alcohol percentage the drink can have.
    # @option opts [Float] :min_caffeine The minimum amount of caffeine in milligrams the drink must have per serving.
    # @option opts [Float] :max_caffeine The maximum amount of caffeine in milligrams the drink can have per serving.
    # @option opts [String] :sort The attribute by which to sort the drinks.
    # @option opts [String] :sort_direction Whether to sort ascending or descending (ASC or DESC).
    # @option opts [Integer] :offset The number of drinks to skip, between 0 and 90.
    # @option opts [Integer] :number The number of drinks, between 1 and 10.
    # @return [SearchDrinksAPI200Response]
    def search_drinks_api(opts = {})
      data, _status_code, _headers = search_drinks_api_with_http_info(opts)
      data
    end

    # Search Drinks API
    # Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [String] :glass_types A comma-separated list (interpreted as OR) of glass types that the drink should be served in.
    # @option opts [String] :flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink.
    # @option opts [String] :diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian.
    # @option opts [String] :include_ingredients A comma-separated list of ingredients that should/must be used in the drinks.
    # @option opts [String] :exclude_ingredients A comma-separated list of ingredients or ingredient types that the drinks must not contain.
    # @option opts [Float] :min_calories The minimum amount of calories the drink must have per serving.
    # @option opts [Float] :max_calories The maximum amount of calories the drink can have per serving.
    # @option opts [Float] :min_carbs The minimum amount of carbohydrates in grams the drink must have per serving.
    # @option opts [Float] :max_carbs The maximum amount of carbohydrates in grams the drink can have per serving.
    # @option opts [Float] :min_protein The minimum amount of protein in grams the drink must have per serving.
    # @option opts [Float] :max_protein The maximum amount of protein in grams the drink can have per serving.
    # @option opts [Float] :min_fat The minimum amount of fat in grams the drink must have per serving.
    # @option opts [Float] :max_fat The maximum amount of fat in grams the drink can have per serving.
    # @option opts [Float] :min_alcohol_percent The minimum alcohol percentage the drink must have.
    # @option opts [Float] :max_alcohol_percent The maximum alcohol percentage the drink can have.
    # @option opts [Float] :min_caffeine The minimum amount of caffeine in milligrams the drink must have per serving.
    # @option opts [Float] :max_caffeine The maximum amount of caffeine in milligrams the drink can have per serving.
    # @option opts [String] :sort The attribute by which to sort the drinks.
    # @option opts [String] :sort_direction Whether to sort ascending or descending (ASC or DESC).
    # @option opts [Integer] :offset The number of drinks to skip, between 0 and 90.
    # @option opts [Integer] :number The number of drinks, between 1 and 10.
    # @return [Array<(SearchDrinksAPI200Response, Integer, Hash)>] SearchDrinksAPI200Response data, response status code and response headers
    def search_drinks_api_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FoodApi.search_drinks_api ...'
      end
      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"query"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"query\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'glass_types'].nil? && opts[:'glass_types'].to_s.length > 200
        fail ArgumentError, 'invalid value for "opts[:"glass_types"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 200.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'glass_types'].nil? && opts[:'glass_types'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"glass_types\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'flavors'].nil? && opts[:'flavors'].to_s.length > 200
        fail ArgumentError, 'invalid value for "opts[:"flavors"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 200.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'flavors'].nil? && opts[:'flavors'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"flavors\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'diet'].nil? && opts[:'diet'].to_s.length > 30
        fail ArgumentError, 'invalid value for "opts[:"diet"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 30.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'diet'].nil? && opts[:'diet'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"diet\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'include_ingredients'].nil? && opts[:'include_ingredients'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"include_ingredients"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'include_ingredients'].nil? && opts[:'include_ingredients'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"include_ingredients\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'exclude_ingredients'].nil? && opts[:'exclude_ingredients'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"exclude_ingredients"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'exclude_ingredients'].nil? && opts[:'exclude_ingredients'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"exclude_ingredients\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'min_calories'].nil? && opts[:'min_calories'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_calories"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_calories'].nil? && opts[:'min_calories'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_calories"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calories'].nil? && opts[:'max_calories'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_calories"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calories'].nil? && opts[:'max_calories'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_calories"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_carbs'].nil? && opts[:'min_carbs'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_carbs"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_carbs'].nil? && opts[:'min_carbs'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_carbs"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_carbs'].nil? && opts[:'max_carbs'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_carbs"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_carbs'].nil? && opts[:'max_carbs'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_carbs"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_protein'].nil? && opts[:'min_protein'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_protein"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_protein'].nil? && opts[:'min_protein'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_protein"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_protein'].nil? && opts[:'max_protein'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_protein"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_protein'].nil? && opts[:'max_protein'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_protein"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fat'].nil? && opts[:'min_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_fat"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fat'].nil? && opts[:'min_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_fat"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fat'].nil? && opts[:'max_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_fat"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fat'].nil? && opts[:'max_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_fat"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_alcohol_percent'].nil? && opts[:'min_alcohol_percent'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_alcohol_percent"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_alcohol_percent'].nil? && opts[:'min_alcohol_percent'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_alcohol_percent"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_alcohol_percent'].nil? && opts[:'max_alcohol_percent'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_alcohol_percent"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_alcohol_percent'].nil? && opts[:'max_alcohol_percent'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_alcohol_percent"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_caffeine'].nil? && opts[:'min_caffeine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_caffeine"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_caffeine'].nil? && opts[:'min_caffeine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_caffeine"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_caffeine'].nil? && opts[:'max_caffeine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_caffeine"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_caffeine'].nil? && opts[:'max_caffeine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_caffeine"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'].to_s.length > 100
        fail ArgumentError, 'invalid value for "opts[:"sort"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 100.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"sort\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'sort_direction'].nil? && opts[:'sort_direction'].to_s.length > 4
        fail ArgumentError, 'invalid value for "opts[:"sort_direction"]" when calling FoodApi.search_drinks_api, the character length must be smaller than or equal to 4.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'sort_direction'].nil? && opts[:'sort_direction'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"sort_direction\"]' when calling FoodApi.search_drinks_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'offset'].nil? && opts[:'offset'] > 90
        fail ArgumentError, 'invalid value for "opts[:"offset"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 90.'
      end

      if @api_client.config.client_side_validation && !opts[:'offset'].nil? && opts[:'offset'] < 0
        fail ArgumentError, 'invalid value for "opts[:"offset"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'number'].nil? && opts[:'number'] > 10
        fail ArgumentError, 'invalid value for "opts[:"number"]" when calling FoodApi.search_drinks_api, must be smaller than or equal to 10.'
      end

      if @api_client.config.client_side_validation && !opts[:'number'].nil? && opts[:'number'] < 1
        fail ArgumentError, 'invalid value for "opts[:"number"]" when calling FoodApi.search_drinks_api, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/search-drinks'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'glass-types'] = opts[:'glass_types'] if !opts[:'glass_types'].nil?
      query_params[:'flavors'] = opts[:'flavors'] if !opts[:'flavors'].nil?
      query_params[:'diet'] = opts[:'diet'] if !opts[:'diet'].nil?
      query_params[:'include-ingredients'] = opts[:'include_ingredients'] if !opts[:'include_ingredients'].nil?
      query_params[:'exclude-ingredients'] = opts[:'exclude_ingredients'] if !opts[:'exclude_ingredients'].nil?
      query_params[:'min-calories'] = opts[:'min_calories'] if !opts[:'min_calories'].nil?
      query_params[:'max-calories'] = opts[:'max_calories'] if !opts[:'max_calories'].nil?
      query_params[:'min-carbs'] = opts[:'min_carbs'] if !opts[:'min_carbs'].nil?
      query_params[:'max-carbs'] = opts[:'max_carbs'] if !opts[:'max_carbs'].nil?
      query_params[:'min-protein'] = opts[:'min_protein'] if !opts[:'min_protein'].nil?
      query_params[:'max-protein'] = opts[:'max_protein'] if !opts[:'max_protein'].nil?
      query_params[:'min-fat'] = opts[:'min_fat'] if !opts[:'min_fat'].nil?
      query_params[:'max-fat'] = opts[:'max_fat'] if !opts[:'max_fat'].nil?
      query_params[:'min-alcohol-percent'] = opts[:'min_alcohol_percent'] if !opts[:'min_alcohol_percent'].nil?
      query_params[:'max-alcohol-percent'] = opts[:'max_alcohol_percent'] if !opts[:'max_alcohol_percent'].nil?
      query_params[:'min-caffeine'] = opts[:'min_caffeine'] if !opts[:'min_caffeine'].nil?
      query_params[:'max-caffeine'] = opts[:'max_caffeine'] if !opts[:'max_caffeine'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?
      query_params[:'sort-direction'] = opts[:'sort_direction'] if !opts[:'sort_direction'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'SearchDrinksAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"FoodApi.search_drinks_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FoodApi#search_drinks_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Search Recipes API
    # Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [String] :cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;).
    # @option opts [String] :exclude_cuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;).
    # @option opts [String] :meal_type The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink.
    # @option opts [String] :diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian.
    # @option opts [String] :intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered.
    # @option opts [String] :equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;.
    # @option opts [String] :include_ingredients A comma-separated list of ingredients that should/must be used in the recipes.
    # @option opts [String] :exclude_ingredients A comma-separated list of ingredients or ingredient types that the recipes must not contain.
    # @option opts [Boolean] :fill_ingredients Add information about the ingredients and whether they are used or missing in relation to the query.
    # @option opts [Boolean] :add_recipe_information If set to true, you get more information about the recipes returned.
    # @option opts [Integer] :max_time The maximum time in minutes it should take to prepare and cook the recipe.
    # @option opts [Integer] :min_servings The minimum amount of servings the recipe is for.
    # @option opts [Integer] :max_servings The maximum amount of servings the recipe is for.
    # @option opts [Float] :min_calories The minimum amount of calories the recipe must have per serving.
    # @option opts [Float] :max_calories The maximum amount of calories the recipe can have per serving.
    # @option opts [Float] :min_carbs The minimum amount of carbohydrates in grams the recipe must have per serving.
    # @option opts [Float] :max_carbs The maximum amount of carbohydrates in grams the recipe can have per serving.
    # @option opts [Float] :min_protein The minimum amount of protein in grams the recipe must have per serving.
    # @option opts [Float] :max_protein The maximum amount of protein in grams the recipe can have per serving.
    # @option opts [Float] :min_fat The minimum amount of fat in grams the recipe must have per serving.
    # @option opts [Float] :max_fat The maximum amount of fat in grams the recipe can have per serving.
    # @option opts [Float] :min_sugar The minimum amount of sugar in grams the recipe must have per serving.
    # @option opts [Float] :max_sugar The maximum amount of sugar in grams the recipe can have per serving.
    # @option opts [Float] :min_fiber The minimum amount of fiber in grams the recipe must have per serving.
    # @option opts [Float] :max_fiber The maximum amount of fiber in grams the recipe can have per serving.
    # @option opts [Float] :min_folate The minimum amount of folate in micrograms the recipe must have per serving.
    # @option opts [Float] :max_folate The maximum amount of folate in micrograms the recipe can have per serving.
    # @option opts [Float] :min_folic_acid The minimum amount of folic acid in micrograms the recipe must have per serving.
    # @option opts [Float] :max_folic_acid The maximum amount of folic acid in micrograms the recipe can have per serving.
    # @option opts [Float] :min_iodine The minimum amount of iodine in micrograms the recipe must have per serving.
    # @option opts [Float] :max_iodine The maximum amount of iodine in micrograms the recipe can have per serving.
    # @option opts [Float] :min_iron The minimum amount of iron in milligrams the recipe must have per serving.
    # @option opts [Float] :max_iron The maximum amount of iron in milligrams the recipe can have per serving.
    # @option opts [Float] :min_zinc The minimum amount of zinc in milligrams the recipe must have per serving.
    # @option opts [Float] :max_zinc The maximum amount of zinc in milligrams the recipe can have per serving.
    # @option opts [Float] :min_magnesium The minimum amount of magnesium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_magnesium The maximum amount of magnesium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_manganese The minimum amount of manganese in milligrams the recipe must have per serving.
    # @option opts [Float] :max_manganese The maximum amount of manganese in milligrams the recipe can have per serving.
    # @option opts [Float] :min_phosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving.
    # @option opts [Float] :max_phosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving.
    # @option opts [Float] :min_potassium The minimum amount of potassium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_potassium The maximum amount of potassium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_sodium The minimum amount of sodium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_sodium The maximum amount of sodium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_selenium The minimum amount of selenium in micrograms the recipe must have per serving.
    # @option opts [Float] :max_selenium The maximum amount of selenium in micrograms the recipe can have per serving.
    # @option opts [Float] :min_copper The minimum amount of copper in milligrams the recipe must have per serving.
    # @option opts [Float] :max_copper The maximum amount of copper in milligrams the recipe can have per serving.
    # @option opts [Float] :min_calcium The minimum amount of calcium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_calcium The maximum amount of calcium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_choline The minimum amount of choline in milligrams the recipe must have per serving.
    # @option opts [Float] :max_choline The maximum amount of choline in milligrams the recipe can have per serving.
    # @option opts [Float] :min_cholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving.
    # @option opts [Float] :max_cholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving.
    # @option opts [Float] :min_fluoride The minimum amount of fluoride in milligrams the recipe must have per serving.
    # @option opts [Float] :max_fluoride The maximum amount of fluoride in milligrams the recipe can have per serving.
    # @option opts [Float] :min_alcohol The minimum amount of alcohol in grams the recipe must have per serving.
    # @option opts [Float] :max_alcohol The maximum amount of alcohol in grams the recipe can have per serving.
    # @option opts [Float] :min_caffeine The minimum amount of caffeine in milligrams the recipe must have per serving.
    # @option opts [Float] :max_caffeine The maximum amount of caffeine in milligrams the recipe can have per serving.
    # @option opts [Float] :min_saturated_fat The minimum amount of saturated fat in grams the recipe must have per serving.
    # @option opts [Float] :max_saturated_fat The maximum amount of saturated fat in grams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_a The minimum amount of Vitamin A in IU the recipe must have per serving.
    # @option opts [Float] :max_vitamin_a The maximum amount of Vitamin A in IU the recipe can have per serving.
    # @option opts [Float] :min_vitamin_c The minimum amount of Vitamin C in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_c The maximum amount of Vitamin C in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_d The minimum amount of Vitamin D in micrograms the recipe must have per serving.
    # @option opts [Float] :max_vitamin_d The maximum amount of Vitamin D in micrograms the recipe can have per serving.
    # @option opts [Float] :min_vitamin_e The minimum amount of Vitamin E in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_e The maximum amount of Vitamin E in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_k The minimum amount of Vitamin K in micrograms the recipe must have per serving.
    # @option opts [Float] :max_vitamin_k The maximum amount of Vitamin K in micrograms the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving.
    # @option opts [String] :sort The strategy to sort recipes by.
    # @option opts [String] :sort_direction Whether to sort ascending or descending (ASC or DESC).
    # @option opts [Integer] :offset The number of recipes to skip, between 0 and 900.
    # @option opts [Integer] :number The number of recipes, between 1 and 100.
    # @return [SearchRecipesAPI200Response]
    def search_recipes_api(opts = {})
      data, _status_code, _headers = search_recipes_api_with_http_info(opts)
      data
    end

    # Search Recipes API
    # Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [String] :cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;).
    # @option opts [String] :exclude_cuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;).
    # @option opts [String] :meal_type The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink.
    # @option opts [String] :diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian.
    # @option opts [String] :intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered.
    # @option opts [String] :equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;.
    # @option opts [String] :include_ingredients A comma-separated list of ingredients that should/must be used in the recipes.
    # @option opts [String] :exclude_ingredients A comma-separated list of ingredients or ingredient types that the recipes must not contain.
    # @option opts [Boolean] :fill_ingredients Add information about the ingredients and whether they are used or missing in relation to the query.
    # @option opts [Boolean] :add_recipe_information If set to true, you get more information about the recipes returned.
    # @option opts [Integer] :max_time The maximum time in minutes it should take to prepare and cook the recipe.
    # @option opts [Integer] :min_servings The minimum amount of servings the recipe is for.
    # @option opts [Integer] :max_servings The maximum amount of servings the recipe is for.
    # @option opts [Float] :min_calories The minimum amount of calories the recipe must have per serving.
    # @option opts [Float] :max_calories The maximum amount of calories the recipe can have per serving.
    # @option opts [Float] :min_carbs The minimum amount of carbohydrates in grams the recipe must have per serving.
    # @option opts [Float] :max_carbs The maximum amount of carbohydrates in grams the recipe can have per serving.
    # @option opts [Float] :min_protein The minimum amount of protein in grams the recipe must have per serving.
    # @option opts [Float] :max_protein The maximum amount of protein in grams the recipe can have per serving.
    # @option opts [Float] :min_fat The minimum amount of fat in grams the recipe must have per serving.
    # @option opts [Float] :max_fat The maximum amount of fat in grams the recipe can have per serving.
    # @option opts [Float] :min_sugar The minimum amount of sugar in grams the recipe must have per serving.
    # @option opts [Float] :max_sugar The maximum amount of sugar in grams the recipe can have per serving.
    # @option opts [Float] :min_fiber The minimum amount of fiber in grams the recipe must have per serving.
    # @option opts [Float] :max_fiber The maximum amount of fiber in grams the recipe can have per serving.
    # @option opts [Float] :min_folate The minimum amount of folate in micrograms the recipe must have per serving.
    # @option opts [Float] :max_folate The maximum amount of folate in micrograms the recipe can have per serving.
    # @option opts [Float] :min_folic_acid The minimum amount of folic acid in micrograms the recipe must have per serving.
    # @option opts [Float] :max_folic_acid The maximum amount of folic acid in micrograms the recipe can have per serving.
    # @option opts [Float] :min_iodine The minimum amount of iodine in micrograms the recipe must have per serving.
    # @option opts [Float] :max_iodine The maximum amount of iodine in micrograms the recipe can have per serving.
    # @option opts [Float] :min_iron The minimum amount of iron in milligrams the recipe must have per serving.
    # @option opts [Float] :max_iron The maximum amount of iron in milligrams the recipe can have per serving.
    # @option opts [Float] :min_zinc The minimum amount of zinc in milligrams the recipe must have per serving.
    # @option opts [Float] :max_zinc The maximum amount of zinc in milligrams the recipe can have per serving.
    # @option opts [Float] :min_magnesium The minimum amount of magnesium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_magnesium The maximum amount of magnesium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_manganese The minimum amount of manganese in milligrams the recipe must have per serving.
    # @option opts [Float] :max_manganese The maximum amount of manganese in milligrams the recipe can have per serving.
    # @option opts [Float] :min_phosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving.
    # @option opts [Float] :max_phosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving.
    # @option opts [Float] :min_potassium The minimum amount of potassium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_potassium The maximum amount of potassium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_sodium The minimum amount of sodium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_sodium The maximum amount of sodium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_selenium The minimum amount of selenium in micrograms the recipe must have per serving.
    # @option opts [Float] :max_selenium The maximum amount of selenium in micrograms the recipe can have per serving.
    # @option opts [Float] :min_copper The minimum amount of copper in milligrams the recipe must have per serving.
    # @option opts [Float] :max_copper The maximum amount of copper in milligrams the recipe can have per serving.
    # @option opts [Float] :min_calcium The minimum amount of calcium in milligrams the recipe must have per serving.
    # @option opts [Float] :max_calcium The maximum amount of calcium in milligrams the recipe can have per serving.
    # @option opts [Float] :min_choline The minimum amount of choline in milligrams the recipe must have per serving.
    # @option opts [Float] :max_choline The maximum amount of choline in milligrams the recipe can have per serving.
    # @option opts [Float] :min_cholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving.
    # @option opts [Float] :max_cholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving.
    # @option opts [Float] :min_fluoride The minimum amount of fluoride in milligrams the recipe must have per serving.
    # @option opts [Float] :max_fluoride The maximum amount of fluoride in milligrams the recipe can have per serving.
    # @option opts [Float] :min_alcohol The minimum amount of alcohol in grams the recipe must have per serving.
    # @option opts [Float] :max_alcohol The maximum amount of alcohol in grams the recipe can have per serving.
    # @option opts [Float] :min_caffeine The minimum amount of caffeine in milligrams the recipe must have per serving.
    # @option opts [Float] :max_caffeine The maximum amount of caffeine in milligrams the recipe can have per serving.
    # @option opts [Float] :min_saturated_fat The minimum amount of saturated fat in grams the recipe must have per serving.
    # @option opts [Float] :max_saturated_fat The maximum amount of saturated fat in grams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_a The minimum amount of Vitamin A in IU the recipe must have per serving.
    # @option opts [Float] :max_vitamin_a The maximum amount of Vitamin A in IU the recipe can have per serving.
    # @option opts [Float] :min_vitamin_c The minimum amount of Vitamin C in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_c The maximum amount of Vitamin C in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_d The minimum amount of Vitamin D in micrograms the recipe must have per serving.
    # @option opts [Float] :max_vitamin_d The maximum amount of Vitamin D in micrograms the recipe can have per serving.
    # @option opts [Float] :min_vitamin_e The minimum amount of Vitamin E in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_e The maximum amount of Vitamin E in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_k The minimum amount of Vitamin K in micrograms the recipe must have per serving.
    # @option opts [Float] :max_vitamin_k The maximum amount of Vitamin K in micrograms the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving.
    # @option opts [Float] :min_vitamin_b12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving.
    # @option opts [Float] :max_vitamin_b12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving.
    # @option opts [String] :sort The strategy to sort recipes by.
    # @option opts [String] :sort_direction Whether to sort ascending or descending (ASC or DESC).
    # @option opts [Integer] :offset The number of recipes to skip, between 0 and 900.
    # @option opts [Integer] :number The number of recipes, between 1 and 100.
    # @return [Array<(SearchRecipesAPI200Response, Integer, Hash)>] SearchRecipesAPI200Response data, response status code and response headers
    def search_recipes_api_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FoodApi.search_recipes_api ...'
      end
      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"query"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"query\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'cuisines'].nil? && opts[:'cuisines'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"cuisines"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'cuisines'].nil? && opts[:'cuisines'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"cuisines\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'exclude_cuisines'].nil? && opts[:'exclude_cuisines'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"exclude_cuisines"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'exclude_cuisines'].nil? && opts[:'exclude_cuisines'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"exclude_cuisines\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'meal_type'].nil? && opts[:'meal_type'].to_s.length > 30
        fail ArgumentError, 'invalid value for "opts[:"meal_type"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 30.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'meal_type'].nil? && opts[:'meal_type'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"meal_type\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'diet'].nil? && opts[:'diet'].to_s.length > 30
        fail ArgumentError, 'invalid value for "opts[:"diet"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 30.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'diet'].nil? && opts[:'diet'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"diet\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'intolerances'].nil? && opts[:'intolerances'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"intolerances"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'intolerances'].nil? && opts[:'intolerances'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"intolerances\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'equipment'].nil? && opts[:'equipment'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"equipment"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'equipment'].nil? && opts[:'equipment'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"equipment\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'include_ingredients'].nil? && opts[:'include_ingredients'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"include_ingredients"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'include_ingredients'].nil? && opts[:'include_ingredients'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"include_ingredients\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'exclude_ingredients'].nil? && opts[:'exclude_ingredients'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"exclude_ingredients"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'exclude_ingredients'].nil? && opts[:'exclude_ingredients'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"exclude_ingredients\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'max_time'].nil? && opts[:'max_time'] > 10000
        fail ArgumentError, 'invalid value for "opts[:"max_time"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 10000.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_time'].nil? && opts[:'max_time'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_time"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_servings'].nil? && opts[:'min_servings'] > 100
        fail ArgumentError, 'invalid value for "opts[:"min_servings"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_servings'].nil? && opts[:'min_servings'] < 1
        fail ArgumentError, 'invalid value for "opts[:"min_servings"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_servings'].nil? && opts[:'max_servings'] > 100
        fail ArgumentError, 'invalid value for "opts[:"max_servings"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_servings'].nil? && opts[:'max_servings'] < 1
        fail ArgumentError, 'invalid value for "opts[:"max_servings"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_calories'].nil? && opts[:'min_calories'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_calories"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_calories'].nil? && opts[:'min_calories'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_calories"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calories'].nil? && opts[:'max_calories'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_calories"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calories'].nil? && opts[:'max_calories'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_calories"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_carbs'].nil? && opts[:'min_carbs'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_carbs"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_carbs'].nil? && opts[:'min_carbs'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_carbs"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_carbs'].nil? && opts[:'max_carbs'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_carbs"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_carbs'].nil? && opts[:'max_carbs'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_carbs"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_protein'].nil? && opts[:'min_protein'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_protein"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_protein'].nil? && opts[:'min_protein'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_protein"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_protein'].nil? && opts[:'max_protein'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_protein"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_protein'].nil? && opts[:'max_protein'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_protein"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fat'].nil? && opts[:'min_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_fat"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fat'].nil? && opts[:'min_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_fat"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fat'].nil? && opts[:'max_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_fat"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fat'].nil? && opts[:'max_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_fat"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_sugar'].nil? && opts[:'min_sugar'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_sugar"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_sugar'].nil? && opts[:'min_sugar'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_sugar"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_sugar'].nil? && opts[:'max_sugar'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_sugar"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_sugar'].nil? && opts[:'max_sugar'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_sugar"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fiber'].nil? && opts[:'min_fiber'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_fiber"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fiber'].nil? && opts[:'min_fiber'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_fiber"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fiber'].nil? && opts[:'max_fiber'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_fiber"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fiber'].nil? && opts[:'max_fiber'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_fiber"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_folate'].nil? && opts[:'min_folate'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_folate"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_folate'].nil? && opts[:'min_folate'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_folate"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_folate'].nil? && opts[:'max_folate'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_folate"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_folate'].nil? && opts[:'max_folate'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_folate"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_folic_acid'].nil? && opts[:'min_folic_acid'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_folic_acid"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_folic_acid'].nil? && opts[:'min_folic_acid'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_folic_acid"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_folic_acid'].nil? && opts[:'max_folic_acid'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_folic_acid"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_folic_acid'].nil? && opts[:'max_folic_acid'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_folic_acid"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_iodine'].nil? && opts[:'min_iodine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_iodine"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_iodine'].nil? && opts[:'min_iodine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_iodine"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_iodine'].nil? && opts[:'max_iodine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_iodine"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_iodine'].nil? && opts[:'max_iodine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_iodine"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_iron'].nil? && opts[:'min_iron'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_iron"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_iron'].nil? && opts[:'min_iron'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_iron"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_iron'].nil? && opts[:'max_iron'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_iron"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_iron'].nil? && opts[:'max_iron'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_iron"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_zinc'].nil? && opts[:'min_zinc'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_zinc"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_zinc'].nil? && opts[:'min_zinc'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_zinc"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_zinc'].nil? && opts[:'max_zinc'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_zinc"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_zinc'].nil? && opts[:'max_zinc'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_zinc"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_magnesium'].nil? && opts[:'min_magnesium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_magnesium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_magnesium'].nil? && opts[:'min_magnesium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_magnesium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_magnesium'].nil? && opts[:'max_magnesium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_magnesium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_magnesium'].nil? && opts[:'max_magnesium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_magnesium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_manganese'].nil? && opts[:'min_manganese'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_manganese"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_manganese'].nil? && opts[:'min_manganese'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_manganese"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_manganese'].nil? && opts[:'max_manganese'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_manganese"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_manganese'].nil? && opts[:'max_manganese'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_manganese"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_phosphorus'].nil? && opts[:'min_phosphorus'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_phosphorus"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_phosphorus'].nil? && opts[:'min_phosphorus'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_phosphorus"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_phosphorus'].nil? && opts[:'max_phosphorus'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_phosphorus"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_phosphorus'].nil? && opts[:'max_phosphorus'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_phosphorus"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_potassium'].nil? && opts[:'min_potassium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_potassium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_potassium'].nil? && opts[:'min_potassium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_potassium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_potassium'].nil? && opts[:'max_potassium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_potassium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_potassium'].nil? && opts[:'max_potassium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_potassium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_sodium'].nil? && opts[:'min_sodium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_sodium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_sodium'].nil? && opts[:'min_sodium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_sodium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_sodium'].nil? && opts[:'max_sodium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_sodium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_sodium'].nil? && opts[:'max_sodium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_sodium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_selenium'].nil? && opts[:'min_selenium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_selenium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_selenium'].nil? && opts[:'min_selenium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_selenium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_selenium'].nil? && opts[:'max_selenium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_selenium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_selenium'].nil? && opts[:'max_selenium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_selenium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_copper'].nil? && opts[:'min_copper'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_copper"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_copper'].nil? && opts[:'min_copper'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_copper"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_copper'].nil? && opts[:'max_copper'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_copper"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_copper'].nil? && opts[:'max_copper'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_copper"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_calcium'].nil? && opts[:'min_calcium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_calcium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_calcium'].nil? && opts[:'min_calcium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_calcium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calcium'].nil? && opts[:'max_calcium'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_calcium"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_calcium'].nil? && opts[:'max_calcium'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_calcium"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_choline'].nil? && opts[:'min_choline'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_choline"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_choline'].nil? && opts[:'min_choline'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_choline"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_choline'].nil? && opts[:'max_choline'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_choline"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_choline'].nil? && opts[:'max_choline'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_choline"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_cholesterol'].nil? && opts[:'min_cholesterol'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_cholesterol"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_cholesterol'].nil? && opts[:'min_cholesterol'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_cholesterol"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_cholesterol'].nil? && opts[:'max_cholesterol'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_cholesterol"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_cholesterol'].nil? && opts[:'max_cholesterol'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_cholesterol"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fluoride'].nil? && opts[:'min_fluoride'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_fluoride"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_fluoride'].nil? && opts[:'min_fluoride'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_fluoride"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fluoride'].nil? && opts[:'max_fluoride'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_fluoride"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_fluoride'].nil? && opts[:'max_fluoride'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_fluoride"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_alcohol'].nil? && opts[:'min_alcohol'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_alcohol"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_alcohol'].nil? && opts[:'min_alcohol'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_alcohol"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_alcohol'].nil? && opts[:'max_alcohol'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_alcohol"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_alcohol'].nil? && opts[:'max_alcohol'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_alcohol"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_caffeine'].nil? && opts[:'min_caffeine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_caffeine"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_caffeine'].nil? && opts[:'min_caffeine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_caffeine"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_caffeine'].nil? && opts[:'max_caffeine'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_caffeine"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_caffeine'].nil? && opts[:'max_caffeine'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_caffeine"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_saturated_fat'].nil? && opts[:'min_saturated_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_saturated_fat"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_saturated_fat'].nil? && opts[:'min_saturated_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_saturated_fat"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_saturated_fat'].nil? && opts[:'max_saturated_fat'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_saturated_fat"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_saturated_fat'].nil? && opts[:'max_saturated_fat'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_saturated_fat"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_a'].nil? && opts[:'min_vitamin_a'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_a"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_a'].nil? && opts[:'min_vitamin_a'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_a"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_a'].nil? && opts[:'max_vitamin_a'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_a"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_a'].nil? && opts[:'max_vitamin_a'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_a"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_c'].nil? && opts[:'min_vitamin_c'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_c"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_c'].nil? && opts[:'min_vitamin_c'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_c"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_c'].nil? && opts[:'max_vitamin_c'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_c"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_c'].nil? && opts[:'max_vitamin_c'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_c"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_d'].nil? && opts[:'min_vitamin_d'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_d"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_d'].nil? && opts[:'min_vitamin_d'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_d"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_d'].nil? && opts[:'max_vitamin_d'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_d"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_d'].nil? && opts[:'max_vitamin_d'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_d"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_e'].nil? && opts[:'min_vitamin_e'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_e"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_e'].nil? && opts[:'min_vitamin_e'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_e"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_e'].nil? && opts[:'max_vitamin_e'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_e"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_e'].nil? && opts[:'max_vitamin_e'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_e"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_k'].nil? && opts[:'min_vitamin_k'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_k"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_k'].nil? && opts[:'min_vitamin_k'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_k"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_k'].nil? && opts[:'max_vitamin_k'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_k"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_k'].nil? && opts[:'max_vitamin_k'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_k"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b1'].nil? && opts[:'min_vitamin_b1'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b1"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b1'].nil? && opts[:'min_vitamin_b1'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b1"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b1'].nil? && opts[:'max_vitamin_b1'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b1"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b1'].nil? && opts[:'max_vitamin_b1'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b1"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b2'].nil? && opts[:'min_vitamin_b2'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b2"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b2'].nil? && opts[:'min_vitamin_b2'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b2"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b2'].nil? && opts[:'max_vitamin_b2'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b2"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b2'].nil? && opts[:'max_vitamin_b2'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b2"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b3'].nil? && opts[:'min_vitamin_b3'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b3"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b3'].nil? && opts[:'min_vitamin_b3'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b3"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b3'].nil? && opts[:'max_vitamin_b3'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b3"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b3'].nil? && opts[:'max_vitamin_b3'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b3"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b5'].nil? && opts[:'min_vitamin_b5'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b5"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b5'].nil? && opts[:'min_vitamin_b5'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b5"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b5'].nil? && opts[:'max_vitamin_b5'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b5"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b5'].nil? && opts[:'max_vitamin_b5'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b5"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b6'].nil? && opts[:'min_vitamin_b6'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b6"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b6'].nil? && opts[:'min_vitamin_b6'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b6"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b6'].nil? && opts[:'max_vitamin_b6'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b6"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b6'].nil? && opts[:'max_vitamin_b6'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b6"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b12'].nil? && opts[:'min_vitamin_b12'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b12"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_vitamin_b12'].nil? && opts[:'min_vitamin_b12'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_vitamin_b12"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b12'].nil? && opts[:'max_vitamin_b12'] > 99999
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b12"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 99999.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_vitamin_b12'].nil? && opts[:'max_vitamin_b12'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_vitamin_b12"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'].to_s.length > 100
        fail ArgumentError, 'invalid value for "opts[:"sort"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 100.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"sort\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'sort_direction'].nil? && opts[:'sort_direction'].to_s.length > 4
        fail ArgumentError, 'invalid value for "opts[:"sort_direction"]" when calling FoodApi.search_recipes_api, the character length must be smaller than or equal to 4.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'sort_direction'].nil? && opts[:'sort_direction'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"sort_direction\"]' when calling FoodApi.search_recipes_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'offset'].nil? && opts[:'offset'] > 900
        fail ArgumentError, 'invalid value for "opts[:"offset"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 900.'
      end

      if @api_client.config.client_side_validation && !opts[:'offset'].nil? && opts[:'offset'] < 0
        fail ArgumentError, 'invalid value for "opts[:"offset"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'number'].nil? && opts[:'number'] > 100
        fail ArgumentError, 'invalid value for "opts[:"number"]" when calling FoodApi.search_recipes_api, must be smaller than or equal to 100.'
      end

      if @api_client.config.client_side_validation && !opts[:'number'].nil? && opts[:'number'] < 1
        fail ArgumentError, 'invalid value for "opts[:"number"]" when calling FoodApi.search_recipes_api, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/search-recipes'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'cuisines'] = opts[:'cuisines'] if !opts[:'cuisines'].nil?
      query_params[:'exclude-cuisines'] = opts[:'exclude_cuisines'] if !opts[:'exclude_cuisines'].nil?
      query_params[:'meal-type'] = opts[:'meal_type'] if !opts[:'meal_type'].nil?
      query_params[:'diet'] = opts[:'diet'] if !opts[:'diet'].nil?
      query_params[:'intolerances'] = opts[:'intolerances'] if !opts[:'intolerances'].nil?
      query_params[:'equipment'] = opts[:'equipment'] if !opts[:'equipment'].nil?
      query_params[:'include-ingredients'] = opts[:'include_ingredients'] if !opts[:'include_ingredients'].nil?
      query_params[:'exclude-ingredients'] = opts[:'exclude_ingredients'] if !opts[:'exclude_ingredients'].nil?
      query_params[:'fill-ingredients'] = opts[:'fill_ingredients'] if !opts[:'fill_ingredients'].nil?
      query_params[:'add-recipe-information'] = opts[:'add_recipe_information'] if !opts[:'add_recipe_information'].nil?
      query_params[:'max-time'] = opts[:'max_time'] if !opts[:'max_time'].nil?
      query_params[:'min-servings'] = opts[:'min_servings'] if !opts[:'min_servings'].nil?
      query_params[:'max-servings'] = opts[:'max_servings'] if !opts[:'max_servings'].nil?
      query_params[:'min-calories'] = opts[:'min_calories'] if !opts[:'min_calories'].nil?
      query_params[:'max-calories'] = opts[:'max_calories'] if !opts[:'max_calories'].nil?
      query_params[:'min-carbs'] = opts[:'min_carbs'] if !opts[:'min_carbs'].nil?
      query_params[:'max-carbs'] = opts[:'max_carbs'] if !opts[:'max_carbs'].nil?
      query_params[:'min-protein'] = opts[:'min_protein'] if !opts[:'min_protein'].nil?
      query_params[:'max-protein'] = opts[:'max_protein'] if !opts[:'max_protein'].nil?
      query_params[:'min-fat'] = opts[:'min_fat'] if !opts[:'min_fat'].nil?
      query_params[:'max-fat'] = opts[:'max_fat'] if !opts[:'max_fat'].nil?
      query_params[:'min-sugar'] = opts[:'min_sugar'] if !opts[:'min_sugar'].nil?
      query_params[:'max-sugar'] = opts[:'max_sugar'] if !opts[:'max_sugar'].nil?
      query_params[:'min-fiber'] = opts[:'min_fiber'] if !opts[:'min_fiber'].nil?
      query_params[:'max-fiber'] = opts[:'max_fiber'] if !opts[:'max_fiber'].nil?
      query_params[:'min-folate'] = opts[:'min_folate'] if !opts[:'min_folate'].nil?
      query_params[:'max-folate'] = opts[:'max_folate'] if !opts[:'max_folate'].nil?
      query_params[:'min-folic-acid'] = opts[:'min_folic_acid'] if !opts[:'min_folic_acid'].nil?
      query_params[:'max-folic-acid'] = opts[:'max_folic_acid'] if !opts[:'max_folic_acid'].nil?
      query_params[:'min-iodine'] = opts[:'min_iodine'] if !opts[:'min_iodine'].nil?
      query_params[:'max-iodine'] = opts[:'max_iodine'] if !opts[:'max_iodine'].nil?
      query_params[:'min-iron'] = opts[:'min_iron'] if !opts[:'min_iron'].nil?
      query_params[:'max-iron'] = opts[:'max_iron'] if !opts[:'max_iron'].nil?
      query_params[:'min-zinc'] = opts[:'min_zinc'] if !opts[:'min_zinc'].nil?
      query_params[:'max-zinc'] = opts[:'max_zinc'] if !opts[:'max_zinc'].nil?
      query_params[:'min-magnesium'] = opts[:'min_magnesium'] if !opts[:'min_magnesium'].nil?
      query_params[:'max-magnesium'] = opts[:'max_magnesium'] if !opts[:'max_magnesium'].nil?
      query_params[:'min-manganese'] = opts[:'min_manganese'] if !opts[:'min_manganese'].nil?
      query_params[:'max-manganese'] = opts[:'max_manganese'] if !opts[:'max_manganese'].nil?
      query_params[:'min-phosphorus'] = opts[:'min_phosphorus'] if !opts[:'min_phosphorus'].nil?
      query_params[:'max-phosphorus'] = opts[:'max_phosphorus'] if !opts[:'max_phosphorus'].nil?
      query_params[:'min-potassium'] = opts[:'min_potassium'] if !opts[:'min_potassium'].nil?
      query_params[:'max-potassium'] = opts[:'max_potassium'] if !opts[:'max_potassium'].nil?
      query_params[:'min-sodium'] = opts[:'min_sodium'] if !opts[:'min_sodium'].nil?
      query_params[:'max-sodium'] = opts[:'max_sodium'] if !opts[:'max_sodium'].nil?
      query_params[:'min-selenium'] = opts[:'min_selenium'] if !opts[:'min_selenium'].nil?
      query_params[:'max-selenium'] = opts[:'max_selenium'] if !opts[:'max_selenium'].nil?
      query_params[:'min-copper'] = opts[:'min_copper'] if !opts[:'min_copper'].nil?
      query_params[:'max-copper'] = opts[:'max_copper'] if !opts[:'max_copper'].nil?
      query_params[:'min-calcium'] = opts[:'min_calcium'] if !opts[:'min_calcium'].nil?
      query_params[:'max-calcium'] = opts[:'max_calcium'] if !opts[:'max_calcium'].nil?
      query_params[:'min-choline'] = opts[:'min_choline'] if !opts[:'min_choline'].nil?
      query_params[:'max-choline'] = opts[:'max_choline'] if !opts[:'max_choline'].nil?
      query_params[:'min-cholesterol'] = opts[:'min_cholesterol'] if !opts[:'min_cholesterol'].nil?
      query_params[:'max-cholesterol'] = opts[:'max_cholesterol'] if !opts[:'max_cholesterol'].nil?
      query_params[:'min-fluoride'] = opts[:'min_fluoride'] if !opts[:'min_fluoride'].nil?
      query_params[:'max-fluoride'] = opts[:'max_fluoride'] if !opts[:'max_fluoride'].nil?
      query_params[:'min-alcohol'] = opts[:'min_alcohol'] if !opts[:'min_alcohol'].nil?
      query_params[:'max-alcohol'] = opts[:'max_alcohol'] if !opts[:'max_alcohol'].nil?
      query_params[:'min-caffeine'] = opts[:'min_caffeine'] if !opts[:'min_caffeine'].nil?
      query_params[:'max-caffeine'] = opts[:'max_caffeine'] if !opts[:'max_caffeine'].nil?
      query_params[:'min-saturated-fat'] = opts[:'min_saturated_fat'] if !opts[:'min_saturated_fat'].nil?
      query_params[:'max-saturated-fat'] = opts[:'max_saturated_fat'] if !opts[:'max_saturated_fat'].nil?
      query_params[:'min-vitamin-a'] = opts[:'min_vitamin_a'] if !opts[:'min_vitamin_a'].nil?
      query_params[:'max-vitamin-a'] = opts[:'max_vitamin_a'] if !opts[:'max_vitamin_a'].nil?
      query_params[:'min-vitamin-c'] = opts[:'min_vitamin_c'] if !opts[:'min_vitamin_c'].nil?
      query_params[:'max-vitamin-c'] = opts[:'max_vitamin_c'] if !opts[:'max_vitamin_c'].nil?
      query_params[:'min-vitamin-d'] = opts[:'min_vitamin_d'] if !opts[:'min_vitamin_d'].nil?
      query_params[:'max-vitamin-d'] = opts[:'max_vitamin_d'] if !opts[:'max_vitamin_d'].nil?
      query_params[:'min-vitamin-e'] = opts[:'min_vitamin_e'] if !opts[:'min_vitamin_e'].nil?
      query_params[:'max-vitamin-e'] = opts[:'max_vitamin_e'] if !opts[:'max_vitamin_e'].nil?
      query_params[:'min-vitamin-k'] = opts[:'min_vitamin_k'] if !opts[:'min_vitamin_k'].nil?
      query_params[:'max-vitamin-k'] = opts[:'max_vitamin_k'] if !opts[:'max_vitamin_k'].nil?
      query_params[:'min-vitamin-b1'] = opts[:'min_vitamin_b1'] if !opts[:'min_vitamin_b1'].nil?
      query_params[:'max-vitamin-b1'] = opts[:'max_vitamin_b1'] if !opts[:'max_vitamin_b1'].nil?
      query_params[:'min-vitamin-b2'] = opts[:'min_vitamin_b2'] if !opts[:'min_vitamin_b2'].nil?
      query_params[:'max-vitamin-b2'] = opts[:'max_vitamin_b2'] if !opts[:'max_vitamin_b2'].nil?
      query_params[:'min-vitamin-b3'] = opts[:'min_vitamin_b3'] if !opts[:'min_vitamin_b3'].nil?
      query_params[:'max-vitamin-b3'] = opts[:'max_vitamin_b3'] if !opts[:'max_vitamin_b3'].nil?
      query_params[:'min-vitamin-b5'] = opts[:'min_vitamin_b5'] if !opts[:'min_vitamin_b5'].nil?
      query_params[:'max-vitamin-b5'] = opts[:'max_vitamin_b5'] if !opts[:'max_vitamin_b5'].nil?
      query_params[:'min-vitamin-b6'] = opts[:'min_vitamin_b6'] if !opts[:'min_vitamin_b6'].nil?
      query_params[:'max-vitamin-b6'] = opts[:'max_vitamin_b6'] if !opts[:'max_vitamin_b6'].nil?
      query_params[:'min-vitamin-b12'] = opts[:'min_vitamin_b12'] if !opts[:'min_vitamin_b12'].nil?
      query_params[:'max-vitamin-b12'] = opts[:'max_vitamin_b12'] if !opts[:'max_vitamin_b12'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?
      query_params[:'sort-direction'] = opts[:'sort_direction'] if !opts[:'sort_direction'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'SearchRecipesAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"FoodApi.search_recipes_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FoodApi#search_recipes_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Search Restaurants API
    # Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
    # @param lat [Float] The latitude to search around.
    # @param lon [Float] The longitude to search around.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [Integer] :distance The maximum distance of the restaurant in miles around the given location.
    # @option opts [Float] :budget The budget in USD for the meal.
    # @option opts [Float] :min_rating The minimum rating of the restaurants in range [0,5].
    # @option opts [String] :cuisine The cuisine that the restaurants should support.
    # @option opts [Boolean] :is_open Whether the restaurants have to be open now.
    # @option opts [Integer] :page The page of the results.
    # @option opts [String] :sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance.
    # @return [SearchRestaurantsAPI200Response]
    def search_restaurants_api(lat, lon, opts = {})
      data, _status_code, _headers = search_restaurants_api_with_http_info(lat, lon, opts)
      data
    end

    # Search Restaurants API
    # Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
    # @param lat [Float] The latitude to search around.
    # @param lon [Float] The longitude to search around.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query The search query.
    # @option opts [Integer] :distance The maximum distance of the restaurant in miles around the given location.
    # @option opts [Float] :budget The budget in USD for the meal.
    # @option opts [Float] :min_rating The minimum rating of the restaurants in range [0,5].
    # @option opts [String] :cuisine The cuisine that the restaurants should support.
    # @option opts [Boolean] :is_open Whether the restaurants have to be open now.
    # @option opts [Integer] :page The page of the results.
    # @option opts [String] :sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance.
    # @return [Array<(SearchRestaurantsAPI200Response, Integer, Hash)>] SearchRestaurantsAPI200Response data, response status code and response headers
    def search_restaurants_api_with_http_info(lat, lon, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FoodApi.search_restaurants_api ...'
      end
      # verify the required parameter 'lat' is set
      if @api_client.config.client_side_validation && lat.nil?
        fail ArgumentError, "Missing the required parameter 'lat' when calling FoodApi.search_restaurants_api"
      end
      if @api_client.config.client_side_validation && lat > 999
        fail ArgumentError, 'invalid value for "lat" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 999.'
      end

      if @api_client.config.client_side_validation && lat < -999
        fail ArgumentError, 'invalid value for "lat" when calling FoodApi.search_restaurants_api, must be greater than or equal to -999.'
      end

      # verify the required parameter 'lon' is set
      if @api_client.config.client_side_validation && lon.nil?
        fail ArgumentError, "Missing the required parameter 'lon' when calling FoodApi.search_restaurants_api"
      end
      if @api_client.config.client_side_validation && lon > 999
        fail ArgumentError, 'invalid value for "lon" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 999.'
      end

      if @api_client.config.client_side_validation && lon < -999
        fail ArgumentError, 'invalid value for "lon" when calling FoodApi.search_restaurants_api, must be greater than or equal to -999.'
      end

      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"query"]" when calling FoodApi.search_restaurants_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'query'].nil? && opts[:'query'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"query\"]' when calling FoodApi.search_restaurants_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'distance'].nil? && opts[:'distance'] > 10000
        fail ArgumentError, 'invalid value for "opts[:"distance"]" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 10000.'
      end

      if @api_client.config.client_side_validation && !opts[:'distance'].nil? && opts[:'distance'] < 0
        fail ArgumentError, 'invalid value for "opts[:"distance"]" when calling FoodApi.search_restaurants_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'budget'].nil? && opts[:'budget'] > 9999
        fail ArgumentError, 'invalid value for "opts[:"budget"]" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 9999.'
      end

      if @api_client.config.client_side_validation && !opts[:'budget'].nil? && opts[:'budget'] < 0
        fail ArgumentError, 'invalid value for "opts[:"budget"]" when calling FoodApi.search_restaurants_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_rating'].nil? && opts[:'min_rating'] > 5
        fail ArgumentError, 'invalid value for "opts[:"min_rating"]" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 5.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_rating'].nil? && opts[:'min_rating'] < 0
        fail ArgumentError, 'invalid value for "opts[:"min_rating"]" when calling FoodApi.search_restaurants_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'cuisine'].nil? && opts[:'cuisine'].to_s.length > 300
        fail ArgumentError, 'invalid value for "opts[:"cuisine"]" when calling FoodApi.search_restaurants_api, the character length must be smaller than or equal to 300.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'cuisine'].nil? && opts[:'cuisine'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"cuisine\"]' when calling FoodApi.search_restaurants_api, must conform to the pattern #{pattern}."
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] > 9999
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling FoodApi.search_restaurants_api, must be smaller than or equal to 9999.'
      end

      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling FoodApi.search_restaurants_api, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'].to_s.length > 30
        fail ArgumentError, 'invalid value for "opts[:"sort"]" when calling FoodApi.search_restaurants_api, the character length must be smaller than or equal to 30.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'sort'].nil? && opts[:'sort'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"sort\"]' when calling FoodApi.search_restaurants_api, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/search-restaurants'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'lat'] = lat
      query_params[:'lon'] = lon
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'distance'] = opts[:'distance'] if !opts[:'distance'].nil?
      query_params[:'budget'] = opts[:'budget'] if !opts[:'budget'].nil?
      query_params[:'min-rating'] = opts[:'min_rating'] if !opts[:'min_rating'].nil?
      query_params[:'cuisine'] = opts[:'cuisine'] if !opts[:'cuisine'].nil?
      query_params[:'is-open'] = opts[:'is_open'] if !opts[:'is_open'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'SearchRestaurantsAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"FoodApi.search_restaurants_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FoodApi#search_restaurants_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
