=begin
#API League

#API League is a Hub for World Class APIs.

The version of the OpenAPI document: 1.6.4
Contact: mail@apileague.com
Generated by: https://openapi-generator.tech
Generator version: 7.8.0-SNAPSHOT

=end

require 'cgi'

module OpenapiClient
  class KnowledgeApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Random Quote API
    # This API returns a random quote from a collection of quotes. The quotes are from famous people and are in English.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :min_length The minimum length of the quote in letters.
    # @option opts [Integer] :max_length The maximum length of the quote in letters.
    # @return [RandomQuoteAPI200Response]
    def random_quote_api(opts = {})
      data, _status_code, _headers = random_quote_api_with_http_info(opts)
      data
    end

    # Random Quote API
    # This API returns a random quote from a collection of quotes. The quotes are from famous people and are in English.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :min_length The minimum length of the quote in letters.
    # @option opts [Integer] :max_length The maximum length of the quote in letters.
    # @return [Array<(RandomQuoteAPI200Response, Integer, Hash)>] RandomQuoteAPI200Response data, response status code and response headers
    def random_quote_api_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: KnowledgeApi.random_quote_api ...'
      end
      if @api_client.config.client_side_validation && !opts[:'min_length'].nil? && opts[:'min_length'] > 10000
        fail ArgumentError, 'invalid value for "opts[:"min_length"]" when calling KnowledgeApi.random_quote_api, must be smaller than or equal to 10000.'
      end

      if @api_client.config.client_side_validation && !opts[:'min_length'].nil? && opts[:'min_length'] < 1
        fail ArgumentError, 'invalid value for "opts[:"min_length"]" when calling KnowledgeApi.random_quote_api, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_length'].nil? && opts[:'max_length'] > 10000
        fail ArgumentError, 'invalid value for "opts[:"max_length"]" when calling KnowledgeApi.random_quote_api, must be smaller than or equal to 10000.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_length'].nil? && opts[:'max_length'] < 1
        fail ArgumentError, 'invalid value for "opts[:"max_length"]" when calling KnowledgeApi.random_quote_api, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/retrieve-random-quote'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'min-length'] = opts[:'min_length'] if !opts[:'min_length'].nil?
      query_params[:'max-length'] = opts[:'max_length'] if !opts[:'max_length'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RandomQuoteAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"KnowledgeApi.random_quote_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: KnowledgeApi#random_quote_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Random Riddle API
    # The riddles API returns a random riddle or brain-teaser. Riddles are a great way to exercise your brain and keep it sharp. The API supports brain-teasers in three difficulty levels: easy, medium, and hard. You can also get a random riddle without specifying a difficulty level.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :difficulty The difficulty of the riddle, either \&quot;easy\&quot;, \&quot;medium\&quot;, or \&quot;hard\&quot;.
    # @return [RandomRiddleAPI200Response]
    def random_riddle_api(opts = {})
      data, _status_code, _headers = random_riddle_api_with_http_info(opts)
      data
    end

    # Random Riddle API
    # The riddles API returns a random riddle or brain-teaser. Riddles are a great way to exercise your brain and keep it sharp. The API supports brain-teasers in three difficulty levels: easy, medium, and hard. You can also get a random riddle without specifying a difficulty level.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :difficulty The difficulty of the riddle, either \&quot;easy\&quot;, \&quot;medium\&quot;, or \&quot;hard\&quot;.
    # @return [Array<(RandomRiddleAPI200Response, Integer, Hash)>] RandomRiddleAPI200Response data, response status code and response headers
    def random_riddle_api_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: KnowledgeApi.random_riddle_api ...'
      end
      if @api_client.config.client_side_validation && !opts[:'difficulty'].nil? && opts[:'difficulty'].to_s.length > 6
        fail ArgumentError, 'invalid value for "opts[:"difficulty"]" when calling KnowledgeApi.random_riddle_api, the character length must be smaller than or equal to 6.'
      end

      pattern = Regexp.new(/./)
      if @api_client.config.client_side_validation && !opts[:'difficulty'].nil? && opts[:'difficulty'] !~ pattern
        fail ArgumentError, "invalid value for 'opts[:\"difficulty\"]' when calling KnowledgeApi.random_riddle_api, must conform to the pattern #{pattern}."
      end

      # resource path
      local_var_path = '/retrieve-random-riddle'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'difficulty'] = opts[:'difficulty'] if !opts[:'difficulty'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RandomRiddleAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"KnowledgeApi.random_riddle_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: KnowledgeApi#random_riddle_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Random Trivia API
    # This endpoint returns a random piece of trivia like \"Rio de Janeiro was once the capital of Portugal, making it the only European capital outside of Europe.\".
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :max_length The maximum length of the trivia in letters.
    # @return [RandomTriviaAPI200Response]
    def random_trivia_api(opts = {})
      data, _status_code, _headers = random_trivia_api_with_http_info(opts)
      data
    end

    # Random Trivia API
    # This endpoint returns a random piece of trivia like \&quot;Rio de Janeiro was once the capital of Portugal, making it the only European capital outside of Europe.\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :max_length The maximum length of the trivia in letters.
    # @return [Array<(RandomTriviaAPI200Response, Integer, Hash)>] RandomTriviaAPI200Response data, response status code and response headers
    def random_trivia_api_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: KnowledgeApi.random_trivia_api ...'
      end
      if @api_client.config.client_side_validation && !opts[:'max_length'].nil? && opts[:'max_length'] > 10000
        fail ArgumentError, 'invalid value for "opts[:"max_length"]" when calling KnowledgeApi.random_trivia_api, must be smaller than or equal to 10000.'
      end

      if @api_client.config.client_side_validation && !opts[:'max_length'].nil? && opts[:'max_length'] < 0
        fail ArgumentError, 'invalid value for "opts[:"max_length"]" when calling KnowledgeApi.random_trivia_api, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/retrieve-random-trivia'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'max-length'] = opts[:'max_length'] if !opts[:'max_length'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json']) unless header_params['Accept']

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'RandomTriviaAPI200Response'

      # auth_names
      auth_names = opts[:debug_auth_names] || ['apiKey', 'headerApiKey']

      new_options = opts.merge(
        :operation => :"KnowledgeApi.random_trivia_api",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: KnowledgeApi#random_trivia_api\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
